static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xB5, 0xF5, 0x01, 0x0F, 0x1C, 0x25, 0x45, 0x0F, 0x04, 0x48,
        0x76, 0x4E, 0xD0, 0x7D, 0x7F, 0x70, 0x0A, 0x00, 0xD8, 0xDE,
        0xBC, 0x53, 0x85, 0x08, 0x80, 0x02, 0x73, 0x91, 0x4C, 0xE2,
        0x8C, 0x16, 0x93, 0x73, 0x47, 0x4F, 0xF4, 0xCC, 0xAA, 0x00,
        0xB7, 0xCC, 0xEE, 0xB5, 0xBC, 0xC0, 0x01, 0x44, 0x7B, 0x33,
        0xC4, 0xF7, 0xE8, 0xD2, 0x94, 0xC5, 0x99, 0xFB, 0x7B, 0x32,
        0x38, 0x99, 0xC7, 0xAB
    };
    static unsigned char dhg_512[] = {
        0x02
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
